/*
 *  chrono.cpp
 *  Polyphonie
 *
 *  Created by Raphaël Amiot on 23/06/10.
 *  Copyright 2010 E.N.. All rights reserved.
 *
 */

#include <time.h>
#include <sys/time.h>

class Chrono
{
public:
	
    Chrono()
	{
		gettimeofday(&start, NULL);
	
	};// Constructeur
	
	void begin()
	{gettimeofday(&start, NULL);
	};
	
	int elapsed()
	{	gettimeofday(&end, NULL);
		seconds  = end.tv_sec  - start.tv_sec;
		useconds = end.tv_usec - start.tv_usec;
		mtime = ((seconds) * 1000 + useconds/1000.0) + 0.5;
		return mtime;
	};
	
	int elapsed_seconds()
	{	gettimeofday(&end, NULL);
		return ( end.tv_sec  - start.tv_sec);	};
	
	
	unsigned long elapsed_micro()
	{	gettimeofday(&end, NULL);
		return ( (end.tv_sec  - start.tv_sec)  + end.tv_usec - start.tv_usec);	
	};
	
	
private:
	struct timeval start, end;	
    long mtime, seconds, useconds;    
};