/*
 *  matricenaive.cpp
 *  Polyphonie
 *
 *  Created by Raphaël Amiot on 22/06/10.
 *  Copyright 2010 E.N.. All rights reserved.
 *
 */


#include "matricenaive.h"


struct arguments
{
	Matricenaive * itself; Matricenaive * m; Matricenaive * c; int i;
	
};




	
	Matricenaive::Matricenaive(unsigned short row, unsigned short col)
	{
		rows = row;
		columns = col;

		contenu = (unsigned int **)malloc(row * sizeof(unsigned int *));
		for(int i = 0; i < row; i++)
			contenu[i] = (unsigned int *)malloc(col * sizeof(unsigned int));
	}


Matricenaive::Matricenaive() 
{
	rows = 0;
	columns = 0;	
	contenu = NULL;
}



void Matricenaive::fill(unsigned int valeur) {


	for(unsigned short i = 0; i< rows;i++)
		for(unsigned short j = 0; j < columns; j++)
			contenu[i][j] = valeur;
	
}
void Matricenaive::fill(){
	
	
	for(unsigned short i = 0; i< rows;i++)
		for(unsigned short j = 0; j < columns; j++)
			contenu[i][j] = 0;
	
}

void Matricenaive::fillrandom() 
{
	
	for(unsigned short i = 0; i< rows;i++)
		for(unsigned short j = 0; j < columns; j++)
	contenu[i][j] = rand()%2000;  
	
}


void Matricenaive::add(Matricenaive * m, Matricenaive * cible)
{ if(!((rows==m->rows)&&(columns==m->columns)))
	throw 1; 
	
		(*cible).redim(rows,columns);
	for(unsigned short i = 0; i< rows; i++)
		for(unsigned short j = 0; j < columns; j++)
			cible->contenu[i][j] = contenu[i][j] + m->contenu[i][j];
	
	return ;
}


void Matricenaive::times(Matricenaive * m, Matricenaive * cible)
{ if(!((columns==m->rows)))
	throw 1; 
	
	(*cible).redim(rows,m->columns); 	
	for(unsigned short i = 0; i< rows; i++)
		for(unsigned short j = 0; j < m->columns; j++) 
		{ unsigned int sum = 0;
				for(unsigned short k = 0; k < columns; k++)
				sum += contenu[i][k] * m->contenu[k][j];  
			
			cible->contenu[i][j] = sum;
		}
	return ;
}




void Matricenaive::times_threaded_2(Matricenaive * m, Matricenaive * cible)
{ if(!((columns==m->rows)))
	throw 1; 
	
	
	(*cible).redim(rows,m->columns);
	unsigned short i;
	unsigned short j;
	unsigned short k;
	unsigned int sum;
	//#pragma omp parallel num_threads(2)
	#pragma omp parallel for default(shared) private(i, j, k, sum)
	
		for(i = 0; i< rows; i++)
		for(j = 0; j < m->columns; j++)
		{ sum = 0;
			for( k = 0; k < columns; k++)
				sum += contenu[i][k] * m->contenu[k][j]; 
			cible->contenu[i][j] = sum;
		}
	
			return ;
}






void Matricenaive::redim(unsigned short row, unsigned short col)
{
	if(rows==row&&col==columns) 
		return;
	
	if(contenu!=NULL)  
		for(unsigned short i = 0; i< rows;i++)
			free(contenu[i]);
	if(contenu!=NULL)
		free((void *)contenu);
	
	rows = row;
	columns = col;
	
	contenu = (unsigned int **)malloc(row * sizeof(unsigned int *));
	for(int i = 0; i < row; i++)
		contenu[i] = (unsigned int *)malloc(col * sizeof(unsigned int));
	
}



Matricenaive::~Matricenaive(){


	if(contenu!=NULL)
	for(unsigned short i = 0; i< rows;i++)
			free(contenu[i]);
	if(contenu!=NULL)
	free((void *)contenu);


}
	


