/*
 *  matricenaive.h
 *  Polyphonie
 *
 *  Created by Raphaël Amiot on 22/06/10.
 *  Copyright 2010 E.N.. All rights reserved.
 *
 */

#include <stdlib.h>
#include <iostream>
#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <boost/bind.hpp>
#include <boost/threadpool.hpp>
#include <omp.h>

class Matricenaive
{
public:
	
    Matricenaive(unsigned short lg, unsigned short lr); // Constructeur
	Matricenaive();//constructeur sans arguments
	void times_threaded_2(Matricenaive * m, Matricenaive * cible);
	void fill(); //remplis la matrice de 0
	void fill(unsigned int valeur);
	void add(Matricenaive * m, Matricenaive * cible); //additionne deux matrices, met le résultat dans cible; renvoie une exception "1" si problème de taille
	void times(Matricenaive * m, Matricenaive * cible); //multiplie deux matrice; la matrice appellant la méthode est à gauche, le premier argument à droite, met le résultat dans cible; renvoie une exception "1" si problème de taille
	unsigned int ** contenu;  //tableau contenant les valeurs
	~Matricenaive(); //destructeur, fuite de mémoire sinon
	void redim(unsigned short row, unsigned short col); //redimentionne une matrice
	void fillrandom();
	
		unsigned short rows, columns;   //dimensions
private:
	


};